<template>
  <div>
    <!-- desktop pc -->
    <div class="gt-md">
      <div class="row justify-center q-px-md">
        <div
          v-for="(item, index) in dataFromCountry"
          :key="index"
          class="catBtn q-my-sm"
          @click="selected(item.catid)"
          :class="[
            catSelected.includes(Number(item.catid)) ? 'catBtn-bgBlue' : '',
          ]"
        >
          <div class="row">
            <div class="catBtn-icon">
              <img
                :src="showIcon(item.catid)"
                class="catBtn-img"
                :alt="'หนังสือการ์ตูนประเภท ' + item.name"
                :class="[
                  catSelected.includes(Number(item.catid))
                    ? 'catBtn-img-white'
                    : '',
                ]"
              />
            </div>
            <div
              class="catBtn-label col"
              :class="[
                catSelected.includes(Number(item.catid))
                  ? 'catBtn-label-white'
                  : '',
              ]"
            >
              {{ item.name }}
            </div>
          </div>
        </div>
      </div>
      <div class="q-px-md">
        <hr />
      </div>
      <div class="row justify-center q-px-md">
        <div
          v-for="(item, index) in dataFromType"
          :key="index"
          class="catBtn q-my-sm"
          @click="selected(item.catid)"
          :class="[
            catSelected.includes(Number(item.catid)) ? 'catBtn-bgBlue' : '',
          ]"
        >
          <div class="row">
            <div class="catBtn-icon">
              <img
                :src="showIcon(item.catid)"
                class="catBtn-img"
                :alt="'หนังสือการ์ตูนประเภท ' + item.name"
                :class="[
                  catSelected.includes(Number(item.catid))
                    ? 'catBtn-img-white'
                    : '',
                ]"
              />
            </div>
            <div
              class="catBtn-label col"
              :class="[
                catSelected.includes(Number(item.catid))
                  ? 'catBtn-label-white'
                  : '',
              ]"
            >
              {{ item.name }}
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- tablet -->
    <div class="lt-lg gt-xs">
      <div class="row justify-center q-pl-md">
        <div
          v-for="(item, index) in dataFromCountry"
          :key="index"
          class="catBtn-t q-my-sm"
          @click="selected(item.catid)"
          :class="[
            catSelected.includes(Number(item.catid)) ? 'catBtn-bgBlue' : '',
          ]"
          align="center"
        >
          <div
            class="catBtn-t-label"
            :class="[
              catSelected.includes(Number(item.catid))
                ? 'catBtn-label-white'
                : '',
            ]"
          >
            {{ item.name }}
          </div>
        </div>
      </div>
      <hr />
      <div class="row justify-center q-pl-md">
        <div
          v-for="(item, index) in dataFromType"
          :key="index"
          class="catBtn-t q-my-sm"
          @click="selected(item.catid)"
          :class="[
            catSelected.includes(Number(item.catid)) ? 'catBtn-bgBlue' : '',
          ]"
          align="center"
        >
          <div
            class="catBtn-t-label"
            :class="[
              catSelected.includes(Number(item.catid))
                ? 'catBtn-label-white'
                : '',
            ]"
          >
            {{ item.name }}
          </div>
        </div>
      </div>
    </div>

    <!-- Mobile -->
    <div class="lt-sm">
      <div class="row q-pl-sm">
        <div
          v-for="(item, index) in dataFromCountry"
          :key="index"
          class="catBtn-m q-my-sm"
          @click="selected(item.catid)"
          :class="[
            catSelected.includes(Number(item.catid)) ? 'catBtn-bgBlue' : '',
          ]"
          align="center"
        >
          <div
            class="catBtn-m-label"
            :class="[
              catSelected.includes(Number(item.catid))
                ? 'catBtn-label-white'
                : '',
            ]"
          >
            {{ item.name }}
          </div>
        </div>
      </div>
      <hr />
      <div class="row q-pl-sm">
        <div
          v-for="(item, index) in dataFromType"
          :key="index"
          class="catBtn-m q-my-sm"
          @click="selected(item.catid)"
          :class="[
            catSelected.includes(Number(item.catid)) ? 'catBtn-bgBlue' : '',
          ]"
          align="center"
        >
          <div
            class="catBtn-m-label"
            :class="[
              catSelected.includes(Number(item.catid))
                ? 'catBtn-label-white'
                : '',
            ]"
          >
            {{ item.name }}
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";
export default {
  data() {
    return {
      data: [],
      dataFromCountry: [],
      dataFromType: [],
      catSelected: [],
    };
  },
  methods: {
    async selected(id) {
      let catSelectedIndex = this.catSelected.findIndex((x) => x == id);
      if (catSelectedIndex != -1) {
        this.catSelected.splice(catSelectedIndex, 1);
      } else {
        this.catSelected.push(Number(id));
      }
      let dataSend = {
        catid: this.catSelected.map((x) => "[" + x + "]"),
      };
      this.$emit("loadBook", dataSend);
    },
    showIcon(id) {
      let iconFile =
        this.serverpath + "icon/" + id + ".svg?" + Math.random() * 2000;
      return iconFile;
    },
    async loadData() {
      let url = this.serverpath + "showcategory.php";
      let res = await axios.get(url);
      this.data = res.data;
      this.data.sort((a, b) => (a.name > b.name ? 1 : 0));
      console.log(this.data);
      this.dataFromType = this.data.filter((x) => x.type == "0");
      this.dataFromCountry = this.data.filter((x) => x.type != "0");
    },
  },
  mounted() {
    this.loadData();
    if (this.$route.params.cat > 0) {
      this.catSelected.push(Number(this.$route.params.cat));
      let catData = "[" + this.$route.params.cat + "]";
      let catArr = [];
      catArr.push(catData);
      let dataTemp = {
        catid: catArr,
      };
      this.$emit("loadBook", dataTemp);
    }
  },
};
</script>

<style lang="scss" scoped>
.catBtn-bgBlue {
  background-color: #2d6be4;
}
.catBtn-m {
  border: 1px solid black;
  width: 31%;
  height: 40px;
  font-size: 12px;
  padding-top: 3px;
  border-radius: 100px;
  margin-right: 5px;
  cursor: pointer;
}

.catBtn-t {
  border: 1px solid black;
  width: 19%;
  height: 40px;
  font-size: 12px;
  padding-top: 3px;
  border-radius: 100px;
  margin-right: 5px;
  cursor: pointer;
}
.catBtn {
  border: 1px solid black;
  width: 180px;
  border-radius: 100px;
  margin-right: 10px;
  cursor: pointer;
}
.catBtn:hover {
  background-color: #b6cefd;
}
.catBtn-icon {
  width: 65px;
  padding-top: 6px;
  text-align: center;
}
.catBtn-img {
  height: 30px;
}
.catBtn-label {
  padding-top: 8px;
}
.catBtn-label-t {
  padding-top: 3px;
}
.catBtn-img-white {
  filter: invert(100%) sepia(100%) saturate(1%) hue-rotate(306deg)
    brightness(103%) contrast(101%);
}
.catBtn-label-white {
  color: white;
}
.catBtn-m-label {
  padding-top: 7px;
  font-size: 13px;
}
.catBtn-t-label {
  padding-top: 4px;
  font-size: 16px;
}
</style>
